import { LifetimeCollection, Selector } from '../ServiceCollection';
import { IServiceProvider } from './IServiceProvider';
export declare class ServiceProvider<E = any> implements IServiceProvider<E> {
    readonly lifetimes: LifetimeCollection<E>;
    readonly proxy: E;
    readonly root: IServiceProvider<E>;
    readonly isDone: boolean;
    readonly depth: number;
    constructor(lifetimes: LifetimeCollection<E>);
    using(action: (provider: E) => any): void;
    provide<T>(selector: Selector<T, E>): T;
}
